using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using Tidy;
using TidyATL;

namespace testTidyCOMcs
{
    class testTidyCOMcs
    {
        static void Main(string[] args)
        {
            string badHTML = "<span>GENERAL SUMMARY Working under limited direction and within general practices, provides technical expertise by independently determining and developing approaches to solutions for a wide range of complex software engineering problems. Understands company goals, practices and product strategies and applies them when resolving a variety of problems. Uses judgement and creativity and sound technical knowledge to obtain and recommend solutions. Assignments may include new products as well as upgrades and enhancements, or fixes to existing products. PRINCIPAL DUTIES AND RESPONSIBILITIES Develops new software engineering methods or processes, re-evaluate existing processes; designs simulation and test criteria and verifies functionality and performance. Works on the overall design and development of new ideas and products, and develops project plans. Represents the organization on project teams and may perform technical project leadership roles; contributes to the development and achievement of organizational goals and objectives. Duties may include research, evaluation, development and application of new process and methods into products. Sphere of influence is likely to extend outside of work group or department. Work may encompass one or more areas of engineering including mechanical systems, equipment and packages, electronic design, production techniques, product definition and planning, or other related fields. May be responsible for establishing and conducting testing routines, developing or executing project plans, and contributing to budgets and schedules. Provides documentation of work and results; reviews projects against goals and provides status reports. Understands and adheres to cost targets established during the program design phase. SKILLS General knowledge and application of engineering concepts. Problem solving skills. Ability to work independently. Communication skills. Problem solving skills. Ability to multi-task. Ability to work in a team environmant.";
            string fixedHTML = "";
            using (StreamWriter sw = new StreamWriter("TempLog2.txt"))
            {
                sw.Write("The date is: ");
                sw.WriteLine(DateTime.Now);
                sw.WriteLine("The input text is:");
                sw.WriteLine(badHTML);
                fixedHTML = tidy(badHTML);
                sw.WriteLine("The output text is:");
                sw.WriteLine(fixedHTML);
                sw.WriteLine("EOF");
            }
        }
        static public string tidy(string HTMLtext)
        {
            string well_formed_HTML_text = "";
            int status = 0;
            try
            {
                FileInfo optFile = new FileInfo("foo.tidy");
                string errFile = @"foo.errors.txt";

                Document tdoc = new Document();

                if (status >= 0)
                {
                    if (optFile.Exists)
                        status = tdoc.LoadConfig(optFile.FullName);
                }

                if (status >= 0)
                {
                    status = tdoc.SetErrorFile(errFile);
                }

                if (status >= 0)
                {
                    status = tdoc.ParseString(HTMLtext);
                }

                if (status >= 0)
                {
                    status = tdoc.CleanAndRepair();
                }

                if (status >= 0)
                {
                    status = tdoc.RunDiagnostics();
                }

                if (status > 1)
                {
                    tdoc.SetOptBool(TidyOptionId.TidyForceOutput, 1);
                }

                if (status >= 0)
                {
                    well_formed_HTML_text = tdoc.SaveString();
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
                status = -1;
            }

            return well_formed_HTML_text;
        }
    }
}

// eof -testTidyCOMcs
